diff -pruN 6.0.0-2/CMakeLists.txt 6.3.0-1/CMakeLists.txt
--- 6.0.0-2/CMakeLists.txt	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/CMakeLists.txt	2024-05-31 13:28:09.000000000 +0000
@@ -3,13 +3,13 @@
 
 cmake_minimum_required(VERSION 3.16)
 
-set(KF_VERSION "6.0.0") # handled by release scripts
-set(KF_DEP_VERSION "6.0.0") # handled by release scripts
+set(KF_VERSION "6.3.0") # handled by release scripts
+set(KF_DEP_VERSION "6.3.0") # handled by release scripts
 project(KRunner VERSION ${KF_VERSION})
 
 # ECM setup
 include(FeatureSummary)
-find_package(ECM 6.0.0  NO_MODULE)
+find_package(ECM 6.3.0  NO_MODULE)
 set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://commits.kde.org/extra-cmake-modules")
 feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)
 
diff -pruN 6.0.0-2/debian/changelog 6.3.0-1/debian/changelog
--- 6.0.0-2/debian/changelog	2024-05-14 06:41:24.000000000 +0000
+++ 6.3.0-1/debian/changelog	2024-06-09 12:55:17.000000000 +0000
@@ -1,3 +1,11 @@
+kf6-krunner (6.3.0-1) experimental; urgency=medium
+
+  [ Patrick Franz ]
+  * New upstream release (6.3.0).
+  * Update build-deps and deps with the info from cmake.
+
+ -- Patrick Franz <deltaone@debian.org>  Sun, 09 Jun 2024 14:55:17 +0200
+
 kf6-krunner (6.0.0-2) experimental; urgency=medium
 
   * Team upload.
diff -pruN 6.0.0-2/debian/control 6.3.0-1/debian/control
--- 6.0.0-2/debian/control	2024-05-14 06:40:53.000000000 +0000
+++ 6.3.0-1/debian/control	2024-06-08 09:30:12.000000000 +0000
@@ -9,11 +9,11 @@ Build-Depends: cmake (>= 3.16~),
                dh-sequence-kf6,
                dh-sequence-pkgkde-symbolshelper,
                doxygen,
-               extra-cmake-modules (>= 6.0.0~),
-               libkf6config-dev (>= 6.0.0~),
-               libkf6coreaddons-dev (>= 6.0.0~),
-               libkf6i18n-dev (>= 6.0.0~),
-               libkf6itemmodels-dev (>= 6.0.0~),
+               extra-cmake-modules (>= 6.3.0~),
+               libkf6config-dev (>= 6.3.0~),
+               libkf6coreaddons-dev (>= 6.3.0~),
+               libkf6i18n-dev (>= 6.3.0~),
+               libkf6itemmodels-dev (>= 6.3.0~),
                libxkbcommon-dev,
                qt6-base-dev (>= 6.5.0+dfsg~),
                qt6-tools-dev (>= 6.5.0~),
@@ -26,7 +26,7 @@ Rules-Requires-Root: no
 Package: libkf6runner-dev
 Section: libdevel
 Architecture: any
-Depends: extra-cmake-modules (>= 6.0.0~),
+Depends: extra-cmake-modules (>= 6.3.0~),
          libkf6runner6 (= ${binary:Version}),
          qt6-base-dev (>= 6.5.0+dfsg~),
          ${misc:Depends},
diff -pruN 6.0.0-2/debian/upstream/signing-key.asc 6.3.0-1/debian/upstream/signing-key.asc
--- 6.0.0-2/debian/upstream/signing-key.asc	2024-05-14 06:39:10.000000000 +0000
+++ 6.3.0-1/debian/upstream/signing-key.asc	2024-06-07 22:16:50.000000000 +0000
@@ -80,3 +80,24 @@ RUqSlBSJqC4WqZmkB73i16MljvT0+4v2upmud4JK
 oS4=
 =yOFv
 -----END PGP PUBLIC KEY BLOCK-----
+-----BEGIN PGP PUBLIC KEY BLOCK-----
+
+mDMEZZxtxBYJKwYBBAHaRw8BAQdAm/8PHszWuXJwUEeEwowgbi7fIeUDP/r9X14f
+Azm23ay0JU5pY29sYXMgRmVsbGEgPG5pY29sYXMuZmVsbGFAa2RlLm9yZz6IkwQT
+FgoAOxYhBJCpaKyoRTfMJ7meryyN9Yem1KrBBQJlnG8zAhsDBQsJCAcCAiICBhUK
+CQgLAgQWAgMBAh4HAheAAAoJECyN9Yem1KrBeP4BAIKpXwECsL4VtZtg2h6uUCZg
+e6oALUd6LYH6+DAM2cGzAP9nRCB06lOnWPiz3PccQDeGPGTl4fJXM63rXIKvxI8n
+C7QkTmljb2xhcyBGZWxsYSA8bmljb2xhcy5mZWxsYUBnbXguZGU+iJMEExYKADsW
+IQSQqWisqEU3zCe5nq8sjfWHptSqwQUCZZxtxAIbAwULCQgHAgIiAgYVCgkICwIE
+FgIDAQIeBwIXgAAKCRAsjfWHptSqwb/cAQDdwi3Ujltdb58uFEN9Wxvv2a/PmJJr
+v76mHWmXqia0UwD/fpQfF7W6Iv6tEoqE2VQjMdboRqumV2m9lDyB3OPwtg+4MwRl
+nG3EFgkrBgEEAdpHDwEBB0ABCziM0Ive6TFO3hWrLxpYFCti3xUL7fLLdJqIJYHc
+O4h4BBgWCgAgFiEEkKlorKhFN8wnuZ6vLI31h6bUqsEFAmWcbcQCGyAACgkQLI31
+h6bUqsFXfQD9G8xNZ6QbfOeP/ARYPH7xUcc2U4/kPjoP8+R/MRnshPMBANDv6T3y
+BxoNXQRYK65x7ghXOSZcQyBLfVuSQshzf/oBuDgEZZxtxBIKKwYBBAGXVQEFAQEH
+QAOAXtH8j+F4XstbXodRsjUSLSQx3doS6cssY8XiZWZ5AwEIB4h4BBgWCgAgFiEE
+kKlorKhFN8wnuZ6vLI31h6bUqsEFAmWcbcQCGwwACgkQLI31h6bUqsFomwD/Zy41
+I8jssyuukIKsRefmsvFeeMKEJgFp0WuZQaZnKEIBANbtyBSxCOkD+5GYm1cjG6nr
+yPRSi/2EuYie6axT6ZIN
+=Noyp
+-----END PGP PUBLIC KEY BLOCK-----
diff -pruN 6.0.0-2/metainfo.yaml 6.3.0-1/metainfo.yaml
--- 6.0.0-2/metainfo.yaml	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/metainfo.yaml	2024-05-31 13:28:09.000000000 +0000
@@ -1,7 +1,6 @@
 # SPDX-FileCopyrightText: none
 # SPDX-License-Identifier: CC0-1.0
 
-maintainer: alex
 description: Parallelized query system
 tier: 3
 type: solution
diff -pruN 6.0.0-2/src/abstractrunner.h 6.3.0-1/src/abstractrunner.h
--- 6.0.0-2/src/abstractrunner.h	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/src/abstractrunner.h	2024-05-31 13:28:09.000000000 +0000
@@ -231,6 +231,8 @@ protected:
 
     /**
      * Provides access to the runner's configuration object.
+     * This config is saved in the "krunnerrc" file in the [Runners][<pluginId>] config group
+     * Settings should be written in a KDE config module. See https://develop.kde.org/docs/plasma/krunner/#runner-configuration
      */
     KConfigGroup config() const;
 
diff -pruN 6.0.0-2/src/action.h 6.3.0-1/src/action.h
--- 6.0.0-2/src/action.h	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/src/action.h	2024-05-31 13:28:09.000000000 +0000
@@ -48,7 +48,7 @@ public:
     Action &operator=(const Action &other);
 
     /// Check if the action is valid
-    operator bool() const
+    explicit operator bool() const
     {
         return !id().isEmpty();
     }
diff -pruN 6.0.0-2/src/dbusrunner.cpp 6.3.0-1/src/dbusrunner.cpp
--- 6.0.0-2/src/dbusrunner.cpp	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/src/dbusrunner.cpp	2024-05-31 13:28:09.000000000 +0000
@@ -252,9 +252,9 @@ void DBusRunner::matchInternal(KRunner::
                 pendingServices->erase(service);
                 if (reply.isError()) {
                     qCWarning(KRUNNER) << "Error requesting matches; calling" << service << " :" << reply.error().name() << reply.error().message();
-                    return;
+                } else {
+                    context.addMatches(convertMatches(service, reply.value()));
                 }
-                context.addMatches(convertMatches(service, reply.value()));
                 // We are finished when all watchers finished
                 if (pendingServices->size() == 0) {
                     Q_EMIT matchInternalFinished(jobId);
diff -pruN 6.0.0-2/src/kpluginmetadata_utils_p.h 6.3.0-1/src/kpluginmetadata_utils_p.h
--- 6.0.0-2/src/kpluginmetadata_utils_p.h	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/src/kpluginmetadata_utils_p.h	2024-05-31 13:28:09.000000000 +0000
@@ -46,6 +46,7 @@ inline KPluginMetaData parseMetaDataFrom
     copyIfExists(grp, root, "X-Plasma-Request-Actions-Once", false);
     copyIfExists(grp, root, "X-Plasma-Runner-Min-Letter-Count", 0);
     copyIfExists(grp, root, "X-Plasma-Runner-Match-Regex");
+    copyIfExists(grp, root, "X-KDE-ConfigModule"); // DBus-Runners may also specify KCMs
     root.insert(QLatin1String("X-Plasma-Runner-Syntaxes"), QJsonArray::fromStringList(grp.readEntry("X-Plasma-Runner-Syntaxes", QStringList())));
     root.insert(QLatin1String("X-Plasma-Runner-Syntax-Descriptions"),
                 QJsonArray::fromStringList(grp.readEntry("X-Plasma-Runner-Syntax-Descriptions", QStringList())));
diff -pruN 6.0.0-2/src/model/resultsmodel.cpp 6.3.0-1/src/model/resultsmodel.cpp
--- 6.0.0-2/src/model/resultsmodel.cpp	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/src/model/resultsmodel.cpp	2024-05-31 13:28:09.000000000 +0000
@@ -59,12 +59,19 @@ protected:
         if (isCategoryComparison) {
             const int favoriteA = sourceA.data(ResultsModel::FavoriteIndexRole).toInt();
             const int favoriteB = sourceB.data(ResultsModel::FavoriteIndexRole).toInt();
-            if (favoriteA != favoriteB) {
-                return favoriteA > favoriteB;
+            bool isFavoriteA = favoriteA != -1;
+            bool isFavoriteB = favoriteB != -1;
+            if (isFavoriteA && !isFavoriteB) {
+                return false;
+            } else if (!isFavoriteA && isFavoriteB) {
+                return true;
             }
 
-            const int typeA = sourceA.data(ResultsModel::CategoryRelevanceRole).toReal();
-            const int typeB = sourceB.data(ResultsModel::CategoryRelevanceRole).toReal();
+            const int favoritesCount = sourceA.data(ResultsModel::FavoriteCountRole).toInt();
+            const double favoriteAMultiplicationFactor = (favoriteA ? 1 + ((favoritesCount - favoriteA) * 0.2) : 1);
+            const double typeA = sourceA.data(ResultsModel::CategoryRelevanceRole).toReal() * favoriteAMultiplicationFactor;
+            const double favoriteBMultiplicationFactor = (favoriteB ? 1 + ((favoritesCount - favoriteB) * 0.2) : 1);
+            const double typeB = sourceB.data(ResultsModel::CategoryRelevanceRole).toReal() * favoriteBMultiplicationFactor;
             return typeA < typeB;
         }
 
diff -pruN 6.0.0-2/src/model/resultsmodel.h 6.3.0-1/src/model/resultsmodel.h
--- 6.0.0-2/src/model/resultsmodel.h	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/src/model/resultsmodel.h	2024-05-31 13:28:09.000000000 +0000
@@ -19,6 +19,14 @@
 namespace KRunner
 {
 class ResultsModelPrivate;
+
+/**
+ * @class ResultsModel resultsmodel.h <KRunner/ResultsModel>
+ *
+ * A model that exposes and sorts results for a given query.
+ *
+ * @since 6.0
+ */
 class KRUNNER_EXPORT ResultsModel : public QSortFilterProxyModel
 {
     Q_OBJECT
@@ -71,6 +79,7 @@ public:
         UrlsRole,
         QueryMatchRole, /// @internal
         FavoriteIndexRole, /// @internal
+        FavoriteCountRole, /// @internal
     };
     Q_ENUM(Roles)
 
diff -pruN 6.0.0-2/src/model/runnerresultsmodel.cpp 6.3.0-1/src/model/runnerresultsmodel.cpp
--- 6.0.0-2/src/model/runnerresultsmodel.cpp	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/src/model/runnerresultsmodel.cpp	2024-05-31 13:28:09.000000000 +0000
@@ -183,6 +183,12 @@ void RunnerResultsModel::clear()
     m_manager->matchSessionComplete();
 
     setQuerying(false);
+    // When our session is over, the term is also no longer relevant
+    // If the same term is used again, the RunnerManager should be asked again
+    if (!m_queryString.isEmpty()) {
+        m_queryString.clear();
+        Q_EMIT queryStringChanged(m_queryString);
+    }
 
     beginResetModel();
     m_categories.clear();
@@ -312,12 +318,14 @@ QVariant RunnerResultsModel::data(const
             if (match.isValid()) {
                 const QString id = match.runner()->id();
                 int idx = m_favoriteIds.indexOf(id);
-                return idx == -1 ? m_favoriteIds.size() : idx;
+                return idx;
             }
         }
         // Any match that is not a favorite will have a greater index than an actual favorite
         return m_favoriteIds.size();
     }
+    case ResultsModel::FavoriteCountRole:
+        return m_favoriteIds.size();
     // Returns the highest type/role within the group
     case ResultsModel::CategoryRelevanceRole: {
         int highestType = 0;
diff -pruN 6.0.0-2/src/runnercontext.cpp 6.3.0-1/src/runnercontext.cpp
--- 6.0.0-2/src/runnercontext.cpp	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/src/runnercontext.cpp	2024-05-31 13:28:09.000000000 +0000
@@ -39,6 +39,7 @@ public:
         : QSharedData(p)
         , m_manager(p.m_manager)
         , launchCounts(p.launchCounts)
+        , changedLaunchCounts(p.changedLaunchCounts)
     {
     }
 
diff -pruN 6.0.0-2/templates/runner6/runner.kdevtemplate 6.3.0-1/templates/runner6/runner.kdevtemplate
--- 6.0.0-2/templates/runner6/runner.kdevtemplate	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/templates/runner6/runner.kdevtemplate	2024-05-31 13:28:09.000000000 +0000
@@ -62,6 +62,7 @@ Comment[id]=Plasma Runner Template. Sebu
 Comment[it]=Modello di esecutore di Plasma. Un modello di esecutore di Plasma
 Comment[ka]=Plasma-ის დამხმარე პროცესის შაბლონი. Plasma-ის დამხმარე პროცესის შაბლონი
 Comment[ko]=Plasma 실행기 템플릿. Plasma 실행기 템플릿
+Comment[lt]=Plasma paleidiklio šablonas. Plasma paleidiklio šablonas
 Comment[lv]=„Plasma“ palaidēja veidne. „Plasma“ palaidēja veidne
 Comment[nb]=Plasma kjørermal. En Plasma-kjørermal
 Comment[nl]=Sjabloon voor Plasma-runner. Een plasma-starter sjabloon
diff -pruN 6.0.0-2/templates/runner6python/%{APPNAMELC}.py 6.3.0-1/templates/runner6python/%{APPNAMELC}.py
--- 6.0.0-2/templates/runner6python/%{APPNAMELC}.py	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/templates/runner6python/%{APPNAMELC}.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,37 +0,0 @@
-#!/usr/bin/python3
-
-import dbus.service
-from dbus.mainloop.glib import DBusGMainLoop
-from gi.repository import GLib
-
-DBusGMainLoop(set_as_default=True)
-
-objpath = "/runner" # Default value for X-Plasma-DBusRunner-Path metadata property
-iface = "org.kde.krunner1"
-
-
-class Runner(dbus.service.Object):
-    def __init__(self):
-        dbus.service.Object.__init__(self, dbus.service.BusName("org.kde.%{APPNAMELC}", dbus.SessionBus()), objpath)
-
-    @dbus.service.method(iface, in_signature='s', out_signature='a(sssida{sv})')
-    def Match(self, query: str):
-        """This method is used to get the matches and it returns a list of tupels"""
-        if query == "hello":
-            # data, text, icon, type (KRunner::QueryType), relevance (0-1), properties (subtext, category, multiline(bool) and urls)
-            return [("Hello", "Hello from %{APPNAME}!", "document-edit", 100, 1.0, {'subtext': 'Demo Subtext'})]
-        return []
-
-    @dbus.service.method(iface, out_signature='a(sss)')
-    def Actions(self):
-        # id, text, icon
-        return [("id", "Tooltip", "planetkde")]
-
-    @dbus.service.method(iface, in_signature='ss')
-    def Run(self, data: str, action_id: str):
-        print(data, action_id)
-
-
-runner = Runner()
-loop = GLib.MainLoop()
-loop.run()
diff -pruN 6.0.0-2/templates/runner6python/install.sh 6.3.0-1/templates/runner6python/install.sh
--- 6.0.0-2/templates/runner6python/install.sh	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/templates/runner6python/install.sh	2024-05-31 13:28:09.000000000 +0000
@@ -1,6 +1,7 @@
 #!/bin/bash
 
-# Exit if something fails
+# Standalone install script for copying files
+
 set -e
 
 prefix="${XDG_DATA_HOME:-$HOME/.local/share}"
@@ -11,7 +12,7 @@ mkdir -p $krunner_dbusdir
 mkdir -p $services_dir
 
 cp %{APPNAMELC}.desktop $krunner_dbusdir
-printf "[D-BUS Service]\nName=org.kde.%{APPNAMELC}\nExec=/usr/bin/python3 \"$PWD/%{APPNAMELC}.py\"" > $services_dir/org.kde.%{APPNAMELC}.service
+printf "[D-BUS Service]\nName=org.kde.%{APPNAMELC}\nExec=\"$PWD/main.py\"" > $services_dir/org.kde.%{APPNAMELC}.service
 
 kquitapp6 krunner
 
diff -pruN 6.0.0-2/templates/runner6python/krunner-plugininstallerrc 6.3.0-1/templates/runner6python/krunner-plugininstallerrc
--- 6.0.0-2/templates/runner6python/krunner-plugininstallerrc	2024-02-21 11:27:01.000000000 +0000
+++ 6.3.0-1/templates/runner6python/krunner-plugininstallerrc	2024-05-31 13:28:09.000000000 +0000
@@ -1,2 +1,3 @@
+# File for krunner-plugininstaller executable. This allows for easier installation in the "Get New Plugins" button of the config module
 MetaDataFile=%{APPNAMELC}.desktop
-Exec=python3 %{PROJECTDIR}/main.py
+Exec=%{PROJECTDIR}/main.py
diff -pruN 6.0.0-2/templates/runner6python/main.py 6.3.0-1/templates/runner6python/main.py
--- 6.0.0-2/templates/runner6python/main.py	1970-01-01 00:00:00.000000000 +0000
+++ 6.3.0-1/templates/runner6python/main.py	2024-05-31 13:28:09.000000000 +0000
@@ -0,0 +1,37 @@
+#!/usr/bin/python3
+
+import dbus.service
+from dbus.mainloop.glib import DBusGMainLoop
+from gi.repository import GLib
+
+DBusGMainLoop(set_as_default=True)
+
+objpath = "/runner" # Default value for X-Plasma-DBusRunner-Path metadata property
+iface = "org.kde.krunner1"
+
+
+class Runner(dbus.service.Object):
+    def __init__(self):
+        dbus.service.Object.__init__(self, dbus.service.BusName("org.kde.%{APPNAMELC}", dbus.SessionBus()), objpath)
+
+    @dbus.service.method(iface, in_signature='s', out_signature='a(sssida{sv})')
+    def Match(self, query: str):
+        """This method is used to get the matches and it returns a list of tupels"""
+        if query == "hello":
+            # data, text, icon, type (KRunner::QueryType), relevance (0-1), properties (subtext, category, multiline(bool) and urls)
+            return [("Hello", "Hello from %{APPNAME}!", "document-edit", 100, 1.0, {'subtext': 'Demo Subtext'})]
+        return []
+
+    @dbus.service.method(iface, out_signature='a(sss)')
+    def Actions(self):
+        # id, text, icon
+        return [("id", "Tooltip", "planetkde")]
+
+    @dbus.service.method(iface, in_signature='ss')
+    def Run(self, data: str, action_id: str):
+        print(data, action_id)
+
+
+runner = Runner()
+loop = GLib.MainLoop()
+loop.run()
